import { CommandInteraction, ButtonInteraction } from 'discord.js';
import { CommandConfig, HandlerRecord, Event } from '../types/index.js';
import 'node:http';
import './logger.js';

declare const DEBUG_MODE: boolean;
declare const ANSI_REGEX: RegExp;
declare const devLogCommand: (interaction: CommandInteraction) => Promise<void>;
declare const devLogCommandConfig: CommandConfig;
declare const devRestartCommand: (interaction: CommandInteraction) => Promise<void>;
declare const devRestartCommandConfig: CommandConfig;
declare const devStatusCommand: () => {
    embeds: {
        title: string;
        color: 5793266;
        fields: {
            name: string;
            value: string;
            inline: boolean;
        }[];
    }[];
};
declare const devStatusCommandConfig: CommandConfig;
declare function printErrorResponse(error: unknown, interaction: unknown, details?: string, event?: HandlerRecord<Event>): Promise<void>;
declare function sendDebugError(error: unknown): Promise<boolean>;
/**
 * Wait for user to click on the button bar and handle the response
 */
declare function handleDebugButton(interaction: ButtonInteraction): Promise<void>;

export { ANSI_REGEX, DEBUG_MODE, devLogCommand, devLogCommandConfig, devRestartCommand, devRestartCommandConfig, devStatusCommand, devStatusCommandConfig, handleDebugButton, printErrorResponse, sendDebugError };
