import { FlashcoreAdapter } from '../types/index.js';
import 'node:http';
import 'discord.js';
import './logger.js';

declare class FlashcoreFileAdapter<K = string, V = unknown> implements FlashcoreAdapter<K, V> {
    private static DATA_DIR;
    clear(): Promise<boolean>;
    delete(key: K): Promise<boolean>;
    get(key: K): Promise<V | undefined>;
    has(key: K): Promise<boolean>;
    init(): Promise<void>;
    set(key: K, value: V): Promise<boolean>;
    private _getSafeKey;
}

export { FlashcoreFileAdapter };
