import { inspect } from 'node:util';
import { color } from './color.js';
import { getModeColor } from './mode.js';

let g;if(process.env.ROBO_SHARD_MODE){const n=process.env.ROBO_SHARD_MODE,e=process.env.ROBO_SHARD_LONGEST_MODE,r=getModeColor(n);g=color.bold(color.dim(r(n.padEnd(e.length))));}const b=process.env.NODE_ENV!=="production",m=/\x1b\[.*?m/g,d=new Set;function p(n,e,...r){switch(e){case"trace":case"debug":case"info":case"wait":case"event":return f(process.stdout,...r);case"warn":case"error":return f(process.stderr,...r);default:return f(process.stdout,...r)}}function f(n,...e){return new Promise((r,i)=>{const l=e?.map(s=>typeof s=="object"||s instanceof Error||Array.isArray(s)?inspect(s,{colors:!0,depth:null}):s);n.write(l?.join(" ")+`
`,"utf8",s=>{s?i(s):r();});})}const y=100;class E{level;timestamp;data;constructor(e,r){this.level=e,this.data=r,this.timestamp=new Date;}message(){return this.data.map(r=>{if(r instanceof Error)return r.message;if(typeof r=="object")try{return JSON.stringify(r)}catch{return "[unserializable object]"}return r}).join(" ").replace(m,"")}}class c{_customLevels;_enabled;_level;_levelValues;_parent;_prefix;_currentIndex;_drain;_logBuffer;constructor(e){this.setup(e);}setup(e){const{customLevels:r,drain:i=p,enabled:l=!0,level:s,parent:a,prefix:h}=e??{};this._customLevels=r,this._drain=i,this._enabled=l,this._parent=a,this._prefix=h,process.env.ROBOPLAY_ENV?this._level="trace":this._level=s??"info",this._levelValues={...k,...Object.fromEntries(Object.entries(this._customLevels??{}).map(([_,v])=>[_,v.priority]))},this._currentIndex=0,this._logBuffer=new Array(e?.maxEntries??y);}_log(e,r,...i){if(this._parent)return this._parent._log(this._prefix,r,...i);if(!this._enabled||this._drain===p&&this._levelValues[this._level]>this._levelValues[r])return;if(r!=="other"){let a=((this._customLevels?this._customLevels[r]?.label:O[r])??r.padEnd(5))+" -";e&&(a=color.bold(x[r](e+":"))+a),i.unshift(a);}g!==void 0&&i.length>1&&i.unshift(g),b&&(this._logBuffer[this._currentIndex]=new E(r,i),this._currentIndex=(this._currentIndex+1)%this._logBuffer.length);const l=this._drain(this,r,...i);d.add(l),l.finally(()=>{d.delete(l);});}async flush(){if(this._parent)return this._parent.flush();await Promise.allSettled([...d]);}fork(e){return new c({customLevels:this._customLevels,enabled:this._enabled,level:this._level,parent:this,prefix:this._prefix?this._prefix+e:e})}getLevel(){return this._parent?this._parent.getLevel():this._level}getLevelValues(){return this._parent?this._parent.getLevelValues():this._levelValues}getRecentLogs(e=50){if(this._parent)return this._parent.getRecentLogs(e);if(e<=0)return [];e=Math.min(e,this._logBuffer.length);const r=(this._currentIndex-e+this._logBuffer.length)%this._logBuffer.length;let i;return r<this._currentIndex?i=this._logBuffer.slice(r,this._currentIndex):i=this._logBuffer.slice(r).concat(this._logBuffer.slice(0,this._currentIndex)),i.reverse()}setDrain(e){this._drain=e;}trace(...e){this._log(null,"trace",...e);}debug(...e){this._log(null,"debug",...e);}info(...e){this._log(null,"info",...e);}wait(...e){this._log(null,"wait",...e);}log(...e){this._log(null,"other",...e);}event(...e){this._log(null,"event",...e);}ready(...e){this._log(null,"ready",...e);}warn(...e){this._log(null,"warn",...e);}error(...e){this._log(null,"error",...e);}custom(e,...r){this._customLevels?.[e]&&this._log(null,e,...r);}}const k={trace:0,debug:1,info:2,wait:3,other:4,event:5,ready:6,warn:7,error:8},x={trace:color.gray,debug:color.cyan,info:color.blue,wait:color.cyan,event:color.magenta,ready:color.green,warn:color.yellow,error:color.red},O={trace:color.gray("trace".padEnd(5)),debug:color.cyan("debug".padEnd(5)),info:color.blue("info".padEnd(5)),wait:color.cyan("wait".padEnd(5)),event:color.magenta("event".padEnd(5)),ready:color.green("ready".padEnd(5)),warn:color.yellow("warn".padEnd(5)),error:color.red("error".padEnd(5))};let u=null;function t(n){return !u&&n?u=new c(n):u?n&&u.setup(n):u=new c,u}t.flush=async function(){await t().flush();},t.fork=function(n){return t().fork(n)},t.getRecentLogs=function(n=25){return t().getRecentLogs(n)},t.trace=function(...n){return t().trace(...n)},t.debug=function(...n){return t().debug(...n)},t.info=function(...n){return t().info(...n)},t.wait=function(...n){return t().wait(...n)},t.log=function(...n){return t().log(...n)},t.event=function(...n){return t().event(...n)},t.ready=function(...n){return t().ready(...n)},t.warn=function(...n){return t().warn(...n)},t.error=function(...n){return t().error(...n)},t.custom=function(n,...e){return t().custom(n,...e)};

export { m as ANSI_REGEX, b as DEBUG_MODE, c as Logger, t as logger };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=logger.js.map